#include <stdio.h>
#include <conio.h>
#include <math.h>



struct compl {			// pro algebraicky tvar
  float r, i;
};

struct compl_g {		// pro goniometricky a exponencialni tvar
  float z, fi;
};


struct compl secti(struct compl a, struct compl b) {	// scitani v algebraickem tvaru
  struct compl c;
  c.r = a.r + b.r;
  c.i = a.i + b.i;
  return c;
}

struct compl nasob(struct compl a, struct compl b) {	// nasobeni v algebraickem tvaru
  struct compl c;
  c.r = a.r*b.r - a.i*b.i;
  c.i = a.r*b.i + b.r*a.i;
  return c;
}

struct compl_g prevodAG(struct compl a) {	// prevod z algebraickeho tvaru na goniometricky
  struct compl_g c;
  c.z = sqrt(a.r*a.r + a.i*a.i);
  c.fi = atan2(a.i, a.r);
  return c;
}

struct compl prevodGA(struct compl_g a) {	// prevod y goniometrickeho na algebraicky
  struct compl c;
  c.r = a.z*cos(a.fi);
  c.i = a.z*sin(a.fi);
  return c;
}

struct compl delA(struct compl a, struct compl b) {	// deleni v algebraickem
  struct compl c;
  float d = b.r*b.r + b.i*b.i;
  c.r = (a.r*b.r + a.i*b.i)/d;
  c.i = -(a.r*b.i - a.i*b.r)/d;
  return c;
}

struct compl_g delG(struct compl_g a, struct compl_g b) {    // deleni v goniometrickem
  struct compl_g c;
  c.z = a.z/b.z;
  c.fi = a.fi-b.fi;
  return c;
}

float absol(struct compl a) {		// velkost komplexniho cisla
  return sqrt(a.r*a.r + a.i*a.i);
}

struct compl sdruz(struct compl a) {		// komplexne sdruzene
  struct compl c;
  c.r = a.r;
  c.i = -a.i;
  return c;
}


struct compl uloz(char *s) {
  struct compl c;
  printf("%s\n", s);
  sscanf(s, "%f + %f", c.r, c.i);
  return c;
}


int isPrazdnyZnak(char znak) {
  return ((znak > 0) && (znak < 33));
}

int prectiPrazdneZ(char string[], int *zarazka) {
  char znak;
  znak = string[*zarazka];
  while (isPrazdnyZnak(znak)) {
    (*zarazka) ++;
    znak = string[*zarazka];
  }
}


int prectiCislo(char string[], int *zarazka, float *cislo) {
  char znak;
  char cislos[10];
  int i, tecka;

  prectiPrazdneZ(string, zarazka);

  i = 0;
  znak = string[*zarazka + i];
  tecka = 0;
  while ((znak <= '9')&&(znak >= '0')||(znak == '.')) {
    if (tecka) {
      if (znak == '.') {tecka = 2; break;}
    } else {
      if (znak == '.') tecka = 1;
    }
    cislos[i] = znak;
    i ++;
    if (i >= 7) {tecka = 2; break;}
    znak = string[*zarazka + i];
  }
  cislos[i] = 0;
  if (tecka == 2) return 0;
  else {
    (*zarazka) ++;
    return sscanf(cislos, "%g", cislo);
  }
}


struct compl prectiKomplex() {
  int zarazka = 0;
  float cislo = 1;
  int OK = 0;
/*
  hledej +-
  hledej ij
  prvni cifra
  OK = prectiCislo("12k.12", &zarazka, &cislo);
  hledej ij
*/


  OK = prectiCislo(" ", &zarazka, &cislo);
  if (OK) printf("%g\n", cislo);
  else printf("CHYBA\n");
}


main(void) {
  char *r;
  char *A;
  struct compl a,b,c;
  struct compl_g g,h,i;

  a.r = -1.0;
  a.i = 2.0;
  b.r = 3.0;
  b.i = 4.87;


  c = secti(a,b);
  c = nasob(a,b);
  c = delA(a,b);
  g = prevodAG(a);
  h = prevodAG(b);
  i = delG(g,h);
  a = prevodGA(i);


  clrscr();

  A = "12.5";

  prectiKomplex();


/*
  r = "10 + 4.2i";
  printf("%s\n", r);
  c = uloz(r);


  printf("komplexni cislo: %g + %gi\n", c.r, c.i);
//  printf("komplexni cislo: %g + %gi", a.r, a.i);
//  printf("komplexni cislo: %gx(sin(%g)+icos(%g))", g.z, g.fi, g.fi);
//  printf("komplexni cislo: %g + %gi", a.r, a.i);
  */
  return 0;
}