#include <stdio.h>
#include <conio.h>
#include <math.h>


struct compl {			// pro algebraicky tvar
  float r, i;
};

struct compl_g {		// pro goniometricky a exponencialni tvar
  float z, fi;
};


compl secti(compl a, compl b) {	// scitani v algebraickem tvaru
  compl c;
  c.r = a.r + b.r;
  c.i = a.i + b.i;
  return c;
}

compl nasob(compl a, compl b) {	// nasobeni v algebraickem tvaru
  compl c;
  c.r = a.r*b.r - a.i*b.i;
  c.i = a.r*b.i + b.r*a.i;
  return c;
}

compl_g prevod(compl a) {	// prevod z algebraickeho tvaru na goniometricky
  compl_g c;
  c.z = sqrt(a.r*a.r + a.i*a.i);
  c.fi = atan2(a.i, a.r);
  return c;
}

compl prevod(compl_g a) {	// prevod y goniometrickeho na algebraicky
  compl c;
  c.r = a.z*cos(a.fi);
  c.i = a.z*sin(a.fi);
  return c;
}

compl del(compl a, compl b) {	// deleni v algebraickem
  compl c;
  float d = b.r*b.r + b.i*b.i;
  c.r = (a.r*b.r + a.i*b.i)/d;
  c.i = -(a.r*b.i - a.i*b.r)/d;
  return c;
}

compl_g del(compl_g a, compl_g b) {    // deleni v goniometrickem
  compl_g c;
  c.z = a.z/b.z;
  c.fi = a.fi-b.fi;
  return c;
}

float abs(compl a) {		// velkost komplexniho cisla
  return sqrt(a.r*a.r + a.i*a.i);
}

compl sdruz(compl a) {		// komplexne sdruzene
  compl c;
  c.r = a.r;
  c.i = -a.i;
  return c;
}


compl uloz(char *s) {
  compl c;
  printf("%s\n", s);
  sscanf(s, "%f + %f", c.r, c.i);
  return c;
}


main(void) {
  char *r;
  compl a,b,c;
  compl_g g,h,i;

  a.r = -1.0;
  a.i = 2.0;
  b.r = 3.0;
  b.i = 4.87;

  c = secti(a,b);
  c = nasob(a,b);
  c = del(a,b);
  g = prevod(a);
  h = prevod(b);
  i = del(g,h);
  a = prevod(i);


  clrscr();
  r = "10 + 4.2i";
  printf("%s\n", r);
  c = uloz(r);


  printf("komplexni cislo: %g + %gi\n", c.r, c.i);
//  printf("komplexni cislo: %g + %gi", a.r, a.i);
//  printf("komplexni cislo: %gx(sin(%g)+icos(%g))", g.z, g.fi, g.fi);
//  printf("komplexni cislo: %g + %gi", a.r, a.i);
  return 0;
}